import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

import {
  InstanceNameType,
  ScopeType,
} from '@overflow/commons/di/type';

export interface ScopeAnnotationAttributes {
  scope?: ScopeType;
}

export class ScopeAnnotation extends Annotation {
  public readonly attributes: ScopeAnnotationAttributes = {
    scope: ScopeType.Default,
  };

  public constructor(scope: ScopeType | ScopeAnnotationAttributes) {
    super();

    if (undefined !== (<ScopeAnnotationAttributes>scope).scope) {
      this.copyAttributes(this.attributes, <ScopeAnnotationAttributes>scope);
    } else {
      this.attributes.scope = <ScopeType>scope;
    }
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    console.log('Scope');
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('Scope');
  }

}

export const Scope = Decorator.create(ScopeAnnotation);
